#  ICE Revision: $Id: PyFoamApplication.py 7581 2007-06-27 15:29:14Z bgschaid $ 
"""Base class for pyFoam-applications"""

from PyFoam.Basics.FoamOptionParser import FoamOptionParser
from PyFoam.Error import error

import sys

class PyFoamApplication(object):
    def __init__(self,description=None,usage=None,interspersed=False,nr=None):
        """
        @param description: description of the command
        @param usage: Usage
        @param interspersed: Is the command line allowed to be interspersed (options after the arguments)
        """
        self.parser=FoamOptionParser(description=description,usage=usage,interspersed=interspersed)
        self.addOptions()
        self.parser.parse(nr=nr)
        self.opts=self.parser.getOptions()

        self.run()
        
    def addOptions(self):
        """
        Add options to the parser
        """
        pass

    def run(self):
        """
        Run the real application
        """
        error("Not a valid application")
        

    def error(self,*args):
        """
        Prints an error message and exits
        @param args: Arguments that are to be printed
        """
        print "Error in",sys.argv[0],":",
        for a in args:
            print a,
        print
        sys.exit(-1)
        
