#  ICE Revision: $Id: AnalyzedRunner.py 7832 2007-08-28 13:07:26Z bgschaid $ 
"""Command is run and output is analyzed"""

from BasicRunner import BasicRunner
from AnalyzedCommon import AnalyzedCommon

class AnalyzedRunner(AnalyzedCommon,BasicRunner):
    """The output of a command is analyzed while being run

    Side effects (files written etc) depend on the analyzer"""
    
    def __init__(self,analyzer,argv=None,silent=False,logname="PyFoamSolve",server=False,lam=None):
        """ @param analyzer: the analyzer for the output
        argv, silent, logname, server, lam - see BasicRunner"""
        BasicRunner.__init__(self,argv,silent,logname,server=server,lam=lam)
        AnalyzedCommon.__init__(self,logname,analyzer)

    def lineHandle(self,line):
        """Not to be called: calls the analyzer for the current line"""
        AnalyzedCommon.lineHandle(self,line)
        BasicRunner.lineHandle(self,line)
